/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.testdata.VNLogo;

import javax.swing.SwingUtilities;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.testdata.VNLogo.VNLogoShared.*;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(final ParameterProxy p)
    {
        final int pointNumber = p.get(POINT_NUMBER);
        final float aspect = p.get(ASPECT);
        final float distance = p.get(DISTANCE);
        final float meshWidth = p.get(MESH_WIDTH);

        sizeSlider.setValue(pointNumber);

        if (aspectSlider.getMax() < aspect) aspectSlider.setMax(aspect);
        if (aspectSlider.getMin() > aspect) aspectSlider.setMin(aspect);
        aspectSlider.setVal(aspect);

        if (distanceSlider.getMax() < distance) distanceSlider.setMax(distance);
        if (distanceSlider.getMin() > distance) distanceSlider.setMin(distance);
        distanceSlider.setVal(distance);

        if (widthSlider.getMax() < meshWidth) widthSlider.setMax(meshWidth);
        if (widthSlider.getMin() > meshWidth) widthSlider.setMin(meshWidth);
        widthSlider.setVal(meshWidth);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        sizeSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        aspectSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        widthSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        distanceSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setLayout(new java.awt.GridBagLayout());

        sizeSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.INT);
        sizeSlider.setMax(1000);
        sizeSlider.setMin(10);
        sizeSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        sizeSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("detail level"));
        sizeSlider.setName("sizeSlider"); // NOI18N
        sizeSlider.setVerifyInputWhenFocusTarget(false);
        sizeSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                sizeSliderUserAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        add(sizeSlider, gridBagConstraints);

        aspectSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("aspect"));
        aspectSlider.setName("aspectSlider"); // NOI18N
        aspectSlider.setShowingFields(false);
        aspectSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                aspectSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        add(aspectSlider, gridBagConstraints);

        widthSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("ribbon width"));
        widthSlider.setName("widthSlider"); // NOI18N
        widthSlider.setShowingFields(false);
        widthSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                widthSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        add(widthSlider, gridBagConstraints);

        distanceSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("ribbon distance"));
        distanceSlider.setName("distanceSlider"); // NOI18N
        distanceSlider.setShowingFields(false);
        distanceSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                distanceSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        add(distanceSlider, gridBagConstraints);

        filler1.setName("filler1"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void sizeSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_sizeSliderStateChanged
    {//GEN-HEADEREND:event_sizeSliderStateChanged
        if (!sizeSlider.isAdjusting())
            parameters.set(POINT_NUMBER, (Integer) sizeSlider.getValue());
    }//GEN-LAST:event_sizeSliderStateChanged

    private void aspectSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_aspectSliderStateChanged
    {//GEN-HEADEREND:event_aspectSliderStateChanged
//        if (!aspectSlider.isAdjusting())
            parameters.set(ASPECT, aspectSlider.getVal());
    }//GEN-LAST:event_aspectSliderStateChanged

    private void distanceSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_distanceSliderStateChanged
    {//GEN-HEADEREND:event_distanceSliderStateChanged
//        if (!distanceSlider.isAdjusting())
            parameters.set(DISTANCE, distanceSlider.getVal());
    }//GEN-LAST:event_distanceSliderStateChanged

    private void widthSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_widthSliderStateChanged
    {//GEN-HEADEREND:event_widthSliderStateChanged
//        if (!widthSlider.isAdjusting())
            parameters.set(MESH_WIDTH, widthSlider.getVal());
    }//GEN-LAST:event_widthSliderStateChanged

    private void sizeSliderUserAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {//GEN-FIRST:event_sizeSliderUserAction
        if (!sizeSlider.isAdjusting())
           parameters.set(POINT_NUMBER, (Integer) sizeSlider.getValue());        // TODO add your handling code here:
    }//GEN-LAST:event_sizeSliderUserAction

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.gui.widgets.FloatSlider aspectSlider;
    private org.visnow.vn.gui.widgets.FloatSlider distanceSlider;
    private javax.swing.Box.Filler filler1;
    private org.visnow.vn.gui.widgets.ExtendedSlider sizeSlider;
    private org.visnow.vn.gui.widgets.FloatSlider widthSlider;
    // End of variables declaration//GEN-END:variables
}
